/* $VER: Start-AmigaAMP.rexx 1.0 */

OPTIONS RESULTS
OPTIONS FAILAT 21
PARSE ARG files


/* Enter here path and AREXX-Port from AmigaAMP */

amp_path="Work:Music/AmigaAMP"
amp_app  = "Work:Music/AmigaAMP/AmigaAMP"
amp_port = "AMIGAAMP"

olddir=PRAGMA("DIRECTORY", amp_path)


/* Start AmigaAMP */

IF ~SHOW("PORT", amp_port) THEN DO
  IF ~EXISTS(amp_app) THEN DO
    SAY "Couldn't find AmigaAMP!"
    EXIT
  END
  ADDRESS COMMAND "RUN >NIL: "amp_app QUIET
  ADDRESS COMMAND "WaitForPort "amp_port
END

IF ~SHOW("PORT", amp_port) THEN DO
  SAY "Couldn't start AmigaAMP!"
  EXIT
END


/* Open files and start playback */
DO WHILE files~==""
    files=STRIP(files)
    IF files~=="" THEN DO
        IF left(files,1)='"' THEN DO
            PARSE VAR files '"'file'"' files
        END
        ELSE DO
            PARSE VAR files file" "files
        END

        /* Workbench unfortunately doesn't give absolute */
        /* path names for the file arguments and AmigaAMP */
        /* actual path is the AmigaAMP program dir */
        /* So we add path names if file has relative path */
        IF POS(":", file)=0 THEN DO
            IF RIGHT(olddir,1)==":" THEN DO
                file=olddir || file
            END
            ELSE DO
                file=olddir"/"file
            END
        END

        /* Open file */
        IF EXISTS(file) THEN DO
            ADDRESS VALUE amp_port
            ADD NAMES '"'file'"'
        PLAY
        ADDRESS
        END
    END
END

olddir=PRAGMA("DIRECTORY",olddir)


